//+------------------------------------------------------------------+
//|                                                 structReturn.mq5 |
//|                                                              DcK |
//|                                               http://www.xyz.com |
//+------------------------------------------------------------------+
#property copyright "DcK"
#property link      "http://www.xyz.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
struct STest{
   double      a, b;
   
   void           STest(): a(0), b(0)                    {}
   void           STest(double A, double B): a(A), b(B)  {}
   void           STest(STest &s): a(s.a), b(s.b)        {}
   
   static STest   TestMethod();
   
   STest          SelfMod(double c)                { a+=c; b+=c*.5; return this; }
   void           Log(string src="") const         { Print( "STest:"+ StringFormat("{%G, %G, %s}", NormalizeDouble(a,2), NormalizeDouble(b,2), src)); }
};

static STest STest::TestMethod()
{
   STest result(1.1, 2.2);
   STest result2 = result.SelfMod(2);
   result.Log("called from STest::TestMethod");
   result2.Log("called from STest::TestMethod");
   
   //method chaining test:
   result.SelfMod(2).Log("called from STest::TestMethod");
   
   return result;
};

class CTest{
   public:
   double a, b;
   
   STest  TestMethod();
};

STest CTest::TestMethod()
{
   STest result(1.1, 2.2);
   STest result2 = result.SelfMod(2);
   result.Log("called from CTest::TestMethod");
   result2.Log("called from CTest::TestMethod");
   
   //method chaining test:
   result.SelfMod(2).Log("called from CTest::TestMethod");
   
   return result;
};

void TestFunction()
{
   STest result(1.1, 2.2);
   STest result2 = result.SelfMod(2);
   result.Log("called from TestFunction");
   result2.Log("called from TestFunction");
   
   //method chaining test:
   result.SelfMod(2).Log("called from TestFunction");
} 

void OnStart()
{
   // from class:
   CTest* c = new CTest();
   STest s = c.TestMethod();
   
   // from static struct
   STest::TestMethod();
   
   // from TestFunction:
   TestFunction();
   
   // from OnStart:
   STest result(1.1, 2.2);
   STest result2 = result.SelfMod(2);
   result.Log("called from OnStart");
   result2.Log("called from OnStart");
   
   //method chaining test:
   result.SelfMod(2).Log("called from OnStart");
   
   delete(c);
};
